#include "cp_types.h"
#include "cp_proto.h"

/* Deep check for error in combinatorics */

int comb_deep_ck(struct p_data *p,int *vert)
{
  int i,j,v,num,m,n,k;
  struct K_data *pK_ptr;

  pK_ptr=p->packK_ptr;

  /* Basic check of data. */
  for (v=1;v<=p->nodecount;v++)
    {
      if (pK_ptr[v].num<1) 
	{*vert=v;return 1;}
      if ((pK_ptr[v].flower[0]==pK_ptr[v].flower[pK_ptr[v].num])
	&& pK_ptr[v].bdry_flag) 
	{*vert=v;return 2;}
    }
  
  /* Is every petal it's petal's petal? */

  for (v=1;v<=p->nodecount;v++)
    for (j=0;j<=pK_ptr[v].num;j++)
      if (nghb(p,v,pK_ptr[v].flower[j])<0) 
	{*vert=v;return 3;}
  
  /* Is any petal repeated in a flower? */
  for (v=1;v<=p->nodecount;v++)
    {
      num=pK_ptr[v].num+1-(pK_ptr[v].bdry_flag>0);
      for (j=0;j<=num-1;j++)
	for (i=j;j<=num;i++)
	  if (pK_ptr[v].flower[i]==pK_ptr[v].flower[j]) 
	    {*vert=v;return 4;}
    }

  /* Is every petal it's nghb petal's petal? */
  for (v=1;v<=p->nodecount;v++)
    {
      num=pK_ptr[v].num-(pK_ptr[v].bdry_flag>0);
      for (j=0;j<=num;j++)
	if (nghb(p,j,j+1)<0) 
	  {*vert=v;return 5;}
    }

  /* Does orientation of edges agree? If <m,n> is clockwise
     from <v,m>, is <m,v> counterclockwise from <m,n>? */
  
  for (v=1;v<=p->nodecount;v++)
    {
      num=pK_ptr[v].num-1;
      for (j=0;j<=num;j++)
	{
	  m=pK_ptr[v].flower[j];
	  n=pK_ptr[v].flower[j+1];
	  if ((k=nghb(p,m,n)<0)) 
	    {*vert=m;return 6;}
	  if ((pK_ptr[m].bdry_flag && k==pK_ptr[m].num)
	      || pK_ptr[m].flower[k+1]!=v)
	    {*vert=m;return 7;}
	}
    }
  return 0;
} /* comb_deep_ck */
  
      
  
