#include "cp_types.h"
#include "cp_proto.h"

/* Read path data from an open file. */

int readpath(FILE *fp,struct Pathlist **pathlist,int *pathlength)
{
  int count=0;
  double xx,yy;
  char command[50];
  struct Pathlist *trace;
  
  if (!fp) return 0;
  while ( (fscanf(fp,"%s",command)!=EOF) && (strcmp(command,"PATH")!=0) 
	  && (strcmp(command,"END")!=0) );
  if (strcmp(command,"END")==0 || fscanf(fp,"%lf %lf",&xx,&yy)!=2) 
    return 0; /* no points */
  *pathlength=0;
  if ( ((*pathlist)=(struct Pathlist *)calloc(1,sizeof(struct Pathlist)))
       !=NULL ) 
    {
      (*pathlist)->x=xx;(*pathlist)->y=yy;
      count++;
    }
  else return 0; 
  trace=(*pathlist);
  while 
    ( fscanf(fp,"%lf %lf",&xx,&yy)==2 && count<2000
      && ((trace->next=(struct Pathlist *)calloc(1,sizeof
						 (struct Pathlist)))!=NULL ) )
    {
      trace=trace->next;
      trace->x=xx;trace->y=yy;
      count++;
    }
  if (count<3)	/* didn't get enough points */
    {path_free(pathlist); *pathlist=NULL;*pathlength=0;return 0;} 
  trace=(*pathlist);
  while (trace->next!=NULL) trace=trace->next;
  if (trace->x!=(*pathlist)->x || trace->y!=(*pathlist)->y)
    {
      trace->next=(struct Pathlist *)calloc
	(1,sizeof(struct Pathlist));
      trace->next->x=(*pathlist)->x;
      trace->next->y=(*pathlist)->y;
      count++;
    } /* make sure path closes up */
  *pathlength=count;
  return count;
} /* readpath */
