#include "cp_types.h"
#include "cp_proto.h"

/* records new spherical radius calculated elsewhere and makes 
approp curvature changes. Return 0 is some imcompatibility is
found along the way. */

int s_changerad(struct p_data *p,int i,double newr)
{
  int k,j,N,flag=0;
  double newc;
  struct K_data *pK_ptr;
  struct R_data *pR_ptr;

  pK_ptr=p->packK_ptr;
  pR_ptr=p->packR_ptr;
  if (newr<=0) return 0;
  s_anglesum_overlap(p,i,newr,&newc,&flag);
  pR_ptr[i].rad=newr;
  if (!flag) pR_ptr[i].curv=newc;
  N=pK_ptr[i].num;
  if (pK_ptr[i].flower[0]!=pK_ptr[i].flower[pK_ptr[i].num]) N++;
  for (k=0;k<N;k++)
    {
      j=pK_ptr[i].flower[k];
      s_anglesum_overlap(p,j,pR_ptr[j].rad,&newc,&flag);
      if (!flag) pR_ptr[j].curv=newc;
    }
  if (!flag) return 1;
  return 0;
} /* s_changerad */




